#!/bin/sh

HEADERS="Content-Type: application/json; charset=UTF-8"

notify() {
    google_chat_channel="$2"
    spaces_id=""
    message_key=""
    chat_token=""

    case $google_chat_channel in
    "PSEC")
        spaces_id="$PSEC_GOOGLE_CHAT_SPACES_ID"
        message_key="$PSEC_GOOGLE_CHAT_MESSAGE_KEY"
        chat_token="$PSEC_GOOGLE_CHAT_TOKEN"
         printf "\e[0;31m%-6s\e[m\n" "** Info:Google Spaces ID: ${spaces_id} Message Id: ${message_key} Google chat token: ${chat_token}..."
        ;;
    "MALWARE")
        spaces_id="$MALWARE_GOOGLE_CHAT_SPACES_ID"
        message_key="$MALWARE_GOOGLE_CHAT_MESSAGE_KEY"
        chat_token="$MALWARE_GOOGLE_CHAT_TOKEN"
        ;;
    *)
        printf "\e[0;31m%-6s\e[m\n" "** ERROR: Invalid Google Chat channel specified."
        return 1
        ;;
    esac

    if [ -z "${spaces_id}" ] || [ -z "${message_key}" ] || [ -z "${chat_token}" ]; then
        printf "\e[0;33m%-6s\e[m\n" "** INFO: SPACE ID: ${spaces_id} Message Id: ${message_key} Google chat token: ${chat_token}"
        printf "\e[0;31m%-6s\e[m\n" "** ERROR: Google Chat webhook credentials/settings are invalid or have not been found. Skipping notification .."
        return 1
    fi

    webhook="https://chat.googleapis.com/v1/spaces/$spaces_id/messages?key=$message_key&token=$chat_token"

    printf "\e[0;33m%-6s\e[m\n" "** INFO: Sending a notification to Product Security via Google Chat .."

    curl -i \
        -s \
        -H "${HEADERS}" \
        -X POST "${webhook}" \
        -d "{
                'text': '${1}'
            }" | grep "HTTP"
}
