#!/bin/sh

if [ -z "${PSEC_MALWARE_SCANNER_SLACK_WEBHOOK}" ]; then
    printf "\e[0;31m%-6s\e[m\n" "** ERROR: Slack webhook not found. Skipping Slack notification.."
    exit 1
fi

JOB_URL=""

if [ "${BUILD_URL}" ]; then
    # we're in jenkins
    JOB_URL="${BUILD_URL}console"
elif [ "${CI_PROJECT_URL}" ] && [ "${CI_JOB_ID}" ]; then
    # we're in gitlab
    JOB_URL="${CI_PROJECT_URL}/-/jobs/${CI_JOB_ID}"
else
    JOB_URL="UNAVAILABLE"
fi

printf "\e[0;31m%-6s\e[m\n" "** INFO: Malware detected in $2! Notifying #team-firestarters"

curl -s -X POST "${PSEC_MALWARE_SCANNER_SLACK_WEBHOOK}" \
    -d "{
            'scanner_name': '$1',
            'product_name': '$2',
            'malware_name': '$3',
            'job_url': '${JOB_URL}'
        }"
